zoukankan      html  css  js  c++  java
  • codeforces118D. Caesar's Legions

    地址:http://www.codeforces.com/problemset/problem/118/D

    题目:

    Gaius Julius Caesar, a famous general, loved to line up his soldiers. Overall the army had n1 footmen and n2 horsemen. Caesar thought that an arrangement is not beautiful if somewhere in the line there are strictly more that k1 footmen standing successively one after another, or there are strictly more than k2 horsemen standing successively one after another. Find the number of beautifularrangements of the soldiers.

    Note that all n1 + n2 warriors should be present at each arrangement. All footmen are considered indistinguishable among themselves. Similarly, all horsemen are considered indistinguishable among themselves.

    Input

    The only line contains four space-separated integers n1, n2, k1, k2 (1 ≤ n1, n2 ≤ 100, 1 ≤ k1, k2 ≤ 10) which represent how many footmen and horsemen there are and the largest acceptable number of footmen and horsemen standing in succession, correspondingly.

    Output

    Print the number of beautiful arrangements of the army modulo 100000000 (108). That is, print the number of such ways to line up the soldiers, that no more than k1 footmen stand successively, and no more than k2 horsemen stand successively.

    Examples
    input
    2 1 1 10
    output
    1
    input
    2 3 1 2
    output
    5
    input
    2 4 1 1
    output
    0
    Note

    Let's mark a footman as 1, and a horseman as 2.

    In the first sample the only beautiful line-up is: 121

    In the second sample 5 beautiful line-ups exist: 12122, 12212, 21212, 21221, 22121

     

    思路:好吧,这题又没自己做出来,看了别人的代码后才会的;

        开始我用dp[i][0]和dp[i][1]来表示前i个人中以0或1结尾的排列方式有多少中,然后。。。。就没有然后了,写不下去了,因为前i个人中,我统计不出步兵和骑兵各有多少人。

        。别人的做法:我只能说构思很巧!,算0结尾的用以1结尾的来计算!

      使用状态dp【i】【j】【k】,i,j:步兵,骑兵个数  k:0是步兵,1是骑兵

      状态方程:for(int k = 1; k <= min(i,k1); k++)
                      dp[i][j][0] = (dp[i][j][0] + dp[i-k][j][1])%MOD;
                  for(int k = 1; k <= min(j,k2); k++)
                      dp[i][j][1] = (dp[i][j][1] + dp[i][j-k][0])%MOD;

     1 #include <iostream>
     2 #include <algorithm>
     3 #include <cstdio>
     4 #include <cmath>
     5 #include <cstring>
     6 #include <queue>
     7 #include <stack>
     8 #include <map>
     9 #include <vector>
    10 
    11 #define PI acos((double)-1)
    12 #define E exp(double(1))
    13 using namespace std;
    14 
    15 int dp[110][110][2];
    16 int main (void)
    17 {
    18     int n1,n2,k1,k2;
    19     cin>>n1>>n2>>k1>>k2;
    20     memset(dp,0,sizeof(dp));
    21     for(int i=1;i<= min(n1,k1);i++)
    22         dp[i][0][0] = 1;
    23     for(int i = 1;i<=min(n2,k2);i++)
    24         dp[0][i][1]=1;
    25     for(int i = 1;i<=n1;i++)
    26         for(int j = 1;j<=n2;j++)
    27         {
    28             for(int k=1;k<=min(i,k1);k++)
    29                 dp[i][j][0]=(dp[i][j][0]+dp[i-k][j][1])%100000000;
    30             for(int k=1;k<=min(j,k2);k++)
    31                 dp[i][j][1]=(dp[i][j][1]+dp[i][j-k][0])%100000000;
    32         }
    33     cout<<(dp[n1][n2][0]+dp[n1][n2][1])%100000000<<endl;
    34     return 0;
    35 }
    View Code
  • 相关阅读:
    51Nod 1267 4个数和为0 二分
    51Nod 1090 3个数和为0 set 二分优化
    51Nod 1001 数组中和等于K的数对 Set
    Codeforces 890C
    Codeforces 890B
    Codeforces 890A
    51nod 1058 N的阶乘的长度 位数公式
    C#调用本机摄像头
    读取、写入excel数据
    数据库笔记--基本应用
  • 原文地址:https://www.cnblogs.com/weeping/p/5364007.html
Copyright © 2011-2022 走看看